<DOCTYPE html>
<html>
    <?php include("include/head.php"); ?>
       
<body>
    <?php include("include/header.php"); ?>

    <section class="section">    
        <article> 
            <?php
            //INITIALISATION des variables

            //Connexion à la BD
            include("include/connexion.php");   
            $bdd=connexionBD('projet_quizz');

            // Select des Quizz
            $reqSQL=
                'SELECT id, titre, contenu
                FROM quizz
                ORDER BY id
            ';

            // Affichage des Quizz
            $requete=$bdd->query($reqSQL);
            while($quizz=$requete->fetch()){ // boucle des Quizz ?>
                <h3>
                    <?php // Affichage du titre du quizz - htmlspecialchars pour nettoyer les données si ça n'avait pas été fait
                    echo htmlspecialchars($quizz['titre']).' - id:'.htmlspecialchars($quizz['id']); ?>
                </h3>           
                <p class="article"> <?php
                    // Affichage du contenu du Quizz - nl2br : new line to br : transforme les passages à la quizz du texte en <br> html
                    echo nl2br(htmlspecialchars($quizz['contenu']));

                    // Select du nombre de questions du Quizz
                    $reqSQL2=
                        'SELECT count(*) as nbQuestions 
                        FROM QUESTIONS 
                        WHERE idQuizz=' .$quizz['id']
                    ;
                    $requete2=$bdd->query($reqSQL2);
                    $nbQuestions=$requete2->fetch();
                    $requete2->closeCursor(); 

                    // affichage du liens vers les questions ?>
                    <em><a href="indexQuizzQuestions.php?
                        idQuizz=<?php echo $quizz['id'] ?>
                        ">
                        <br/> <?php echo $nbQuestions['nbQuestions']?> Questions
                    </a></em>
                </p>                    
            <?php } // Fin de la boucle des billets
            $requete->closeCursor(); ?>
        </article>

    </section>
    <?php include("include/footer.php"); ?>
</body>
</html>