<DOCTYPE html>
<html>
    <head><?php include("include/head.php"); ?></head>  

<body>
    <?php include("include/header.php"); ?>

    <section class="section">    
        <article> 
            <?php
            // Affichage du $_GET pour vérifier
            // on y trouve : [idQuizz]
            // echo '<pre>'; print_r($_GET); echo '</pre>';

            // Initialisation  des variables 
            if (isset($_GET['idQuizz'])) $idQuizz=$_GET['idQuizz'];

            // Connexion à la BD
            include("include/connexion.php");   
            $bdd=connexionBD('projet_quizz');

            // Select du Quizz       
            $reqSQL=
                'SELECT id, titre, contenu 
                FROM quizz WHERE id =' . $idQuizz
            ;
            $requete = $bdd->query($reqSQL); // query ok : l'info est sûre !
            $quizz = $requete->fetch();
            $requete->closeCursor();  

            // Affichage du Quizz   ?> 
            <h3> <?php echo htmlspecialchars($quizz['titre']);?></h3>

            <?php // on entre dans le formulaire complet du quizz 
            //       un seul formulaire ?>
            <form action="indexQuizzReponses.php" method="POST" >   
            <fieldset> 
                <?php // Select des questions           
                $reqSQL=
                    'SELECT id, libelle, numero  
                    FROM questions 
                    WHERE idQuizz = ' .$idQuizz
                    .' ORDER BY numero'
                ;
                $requete = $bdd->query($reqSQL); // query ok : l'info est sûre !  

                // boucle pour chaque question      
                while ($question = $requete->fetch()){ 
                    // affichage du numéro et du libellé de la question ?>
                    <p>
                        <strong><?php echo 'question n° '. htmlspecialchars($question['numero']); ?> : </strong>
                        <?php echo nl2br(htmlspecialchars($question['libelle'])); ?>
                    </p>

                     <?php // Select des réponses 
                     $reqSQL=
                        'SELECT id, libelle, numero  
                        FROM reponses 
                        WHERE idQuestion = ' . $question['id'] .
                        ' ORDER BY numero';
                    $requete2 = $bdd->query($reqSQL); // query ok : l'info est sûre !    

                    // on entre dans le formulaire des radio-boutons de la réponse ?>
                    <ul style="list-style:none;"> <?php // boucle pour chaque réponse      
                    while ($reponse = $requete2->fetch()){ ?>
                        <li>  
                            <input  type="radio" 
                                    name=<?php echo $question['numero'] ?> 
                                    value=<?php echo $reponse['numero'] ?>
                            > 
                            réponse n° <?php echo htmlspecialchars($reponse['numero']); ?> 
                            : <?php echo nl2br(htmlspecialchars($reponse['libelle'])); ?>
                        </li>
                    <?php } // fin du while des réponses ?>                  

                    </ul><hr> <?php // affichage d'une ligne     
                    $requete2->closeCursor();

                } // fin du while des questions
                // fermeture du curseur
                $requete->closeCursor(); 
                // on envoie l'idQuizz en hidden ?>   
                <input type="hidden" name="idQuizz" value=<?php echo $idQuizz?>>
                <p><input type="submit" name="validerQuizz" value="Valider le Quizz"></p>
            </fieldset> 
            </form> 
        </article>
    </section>
    <?php include("include/footer.php"); ?>
</body>
</html>