<!--
    Au départ, ce fichier est un copier coller du Quizz Questions
    Les seules modifications :
     - On ajoute checked si c'est la bonne réponse + disabled
     - On ajoute un commentaire sur la réponse donnée 
     => on pourrait tout mettre dans le même fichier
-->
<DOCTYPE html>
<html>
    <head><?php include("include/head.php"); ?></head>  

<body>
    <?php include("include/header.php"); ?>

    <section class="section">    
        <article> 
            <?php
            // Affichage du $_POST pour vérifier
            // on y trouve : [idQuizz], [n°Question]=>n°Réponse
            echo '<pre>'; print_r($_POST); echo '</pre>';
            
            // Initialisation  des variables 
            if (isset($_POST['idQuizz'])) $idQuizz=$_POST['idQuizz'];

            // Connexion à la BD
            include("include/connexion.php");   
            $bdd=connexionBD('projet_quizz');

            // Select du Quizz       
            $reqSQL=
                'SELECT id, titre, contenu 
                FROM quizz WHERE id =' . $idQuizz
            ;
            $requete = $bdd->query($reqSQL); // query ok : l'info est sûre !
            $quizz = $requete->fetch();
            $requete->closeCursor();  

            // Affichage du Quizz   ?> 
            <h3> <?php echo htmlspecialchars($quizz['titre']);?></h3>

            <?php // on entre dans le formulaire complet du quizz 
            //       un seul formulaire ?>
            <form action="indexQuizzQuestions.php">   
            <fieldset> 
                <?php // Select des questions           
                $reqSQL=
                    'SELECT id, libelle, numero  
                    FROM questions 
                    WHERE idQuizz = ' .$idQuizz
                    .' ORDER BY numero'
                ;
                $requete = $bdd->query($reqSQL); // query ok : l'info est sûre !  

                // boucle pour chaque question      
                while ($question = $requete->fetch()){ 
                    // affichage du numéro et du libellé de la question ?>
                    <p>
                        <strong><?php echo 'question n° '. htmlspecialchars($question['numero']); ?> : </strong>
                        <?php echo nl2br(htmlspecialchars($question['libelle'])); ?>
                    </p>

                     <?php // Select des réponses 
                     $reqSQL=
                        'SELECT id, libelle, numero, bonneReponse 
                        FROM reponses 
                        WHERE idQuestion = ' . $question['id'] .
                        ' ORDER BY numero';
                    $requete2 = $bdd->query($reqSQL); // query ok : l'info est sûre !    

                    // on entre dans le formulaire des radio-boutons de la réponse ?>
                    <ul style="list-style:none;"> <?php // boucle pour chaque réponse      
                    while ($reponse = $requete2->fetch()){ ?>
                        <li>  
                            <input  type="radio" 
                                    name=<?php echo $question['numero'] ?> 
                                    value=<?php echo $reponse['numero'] ?>
                                    <?php // on ajoute checked si c'est la bonne réponse 
                                    if ($reponse['bonneReponse']==1) echo 'checked' ?> 
                                    disabled                                  
                            > 
                            réponse n° <?php echo htmlspecialchars($reponse['numero']); ?> 
                            : <?php echo nl2br(htmlspecialchars($reponse['libelle'])); ?>
                            
                            <?php // on regarde si la question en cours est dans le $_POST
                            if (isset($_POST[$question['numero']])){
                                // echo 'question  : '.$question['numero'].'<br>';
                                // on regarde si la réponse en cours est celle du $_POST
                                if( $_POST[$question['numero']] == $reponse['numero']){
                                    //echo 'reponse  : '.$reponse['numero'].'<br>';
                                    // si c'est le cas : c'est la réponse qu'on a donné
                                    echo ' => votre réponse : ';
                                    // on vérifie si cette réponse est la bonne ou pas
                                    if($reponse['bonneReponse']==1) echo 'bonne réponse';
                                    else echo 'mauvaise réponse';
                                }
                            }
                            ?>

                        </li>
                    <?php } // fin du while des réponses ?>                  

                    </ul><hr> <?php // affichage d'une ligne     
                    $requete2->closeCursor();

                } // fin du while des questions
                // fermeture du curseur
                $requete->closeCursor(); 
                // on envoie l'idQuizz en hidden ?>   
                <input type="hidden" name="idQuizz" value=<?php echo $idQuizz?>>
                <p><input type="submit" value="Retour au Quizz"></p>
            </fieldset> 
            </form> 
        </article>
    </section>
    <?php include("include/footer.php"); ?>
</body>
</html>